#include <stdio.h>
#include <stdlib.h>

// deklaracie funkcii
void vypisPola(int *p_pole, int pozicia);
int binarneVyhladanie(int *p_pole, int sh, int hh, int kluc);
void vlozPrvokUsporiadane(int prvok, int *pozicia, int *p_pole, int *velkost);
int odstranPrvok(int prvok, int *pozicia, int *p_pole);
int main (void)
{
    // deklaracia pointera reprezentujuceho pole a dalsich premennych
    int pozicia = 0;
    int * p_pole, velkost, volba, odpoved = 0, prvok, i, index;

    // alokacia priestoru (kapacity pola) na zaklade volby pouzivatela
    do
    {
        printf("Ake velke ulozisko si zelas vytvorit?: \n");
        scanf("%d", &velkost);
    }
    while(velkost <= 0);

    if((p_pole = (int *) malloc(sizeof(int) * velkost)) == NULL)
    {
        printf("Nedostatok pamate. Program sa konci.\n");
        return 1;
    }
    // menu
    do
    {
        printf("1 - vlozenie prvku do pola.\n");
        printf("2 - odstranenie prvku z pola.\n");
        printf("3 - vypisanie obsahu pola.\n");
        printf("4 - hladanie v poli.\n");
        printf("5 - koniec programu.\n");

        scanf("%d", &volba);
        switch(volba)
        {
        case 1:
            printf("Aky prvok chces vlozit do kontajnera?:\n");
            scanf("%d", &prvok);
            vlozPrvokUsporiadane(prvok, &pozicia, p_pole, &velkost);
            break;
        case 2:
            if(pozicia == 0)
                printf("Tvoj kontajner je prazdny, nemas co odstranovat.\n");
            else
            {
                printf("Aky prvok chces odstranit z kontajnera?:\n");
                scanf("%d", &prvok);
                if(odstranPrvok(prvok, &pozicia, p_pole) == 0)
                    printf("Taky prvok sa v kontajneri nenachadza.\n");
            }
            break;
        case 3:
            if(pozicia == 0)
                printf("Tvoj kontajner je prazdny, nemam co vypisat.\n");
            else
                vypisPola(p_pole, pozicia);
            break;
        case 4:
            if(pozicia == 0)
                printf("Tvoj kontajner je prazdny, nemam kde vyhladavat.\n");
            else
            {
                printf("Aky prvok chces vyhladat v kontajneri?:\n");
                scanf("%d", &prvok);
                if((index = binarneVyhladanie(p_pole,0, velkost, prvok)) == -1)
                    printf("Taky prvok sa v kontajneri nenachadza.\n");
                else
                    printf("Index prveho vyskytu hladaneho prvku %d je: %d.\n",prvok, index);
            }
            break;
        default:
            odpoved = 1;
        }
    }
    while(!odpoved);

    // uvolnenie alokovanej oblasti
    free(p_pole);
    p_pole = NULL;

    return 0;
}

// definicie funkcii
void vypisPola(int *p_pole, int pozicia)
{
    int i;
    printf("Prvky pola: ");
    for(i = 0; i < pozicia; i++)
        printf("%d ", *(p_pole + i));
    printf("\n");
}

// ak sa prvok nenjde, tak vrati -1, inak vrati jeho index
int binarneVyhladanie(int *p_pole, int sh, int hh, int kluc)
{
    if (hh < sh)
        return -1;
    int stred = (sh + hh) / 2;  // int stred = sh + (hh - sh) / 2;
    if (kluc == p_pole[stred])
        return stred;
    if (kluc > p_pole[stred])
        return binarneVyhladanie(p_pole, (stred + 1), hh, kluc);
    return binarneVyhladanie(p_pole, sh, (stred - 1), kluc);
}

// vlozenie prvku na spravne miesto, ak sa presiahne velkost pola, tak sa tato automaticky zdvojnasobi
void vlozPrvokUsporiadane(int prvok, int *pozicia, int *p_pole, int *velkost)
{
    int i, j;
    if(*pozicia >= *velkost)
    {
        if((p_pole = (int *) realloc(p_pole, (sizeof(int) * (*velkost) * 2))) == NULL)
        {
            printf("Nedostatok pamate. Program sa konci.\n");
            return;
        }
        printf("Prvok bol vlozeny po zvacseni kontajnera.\n");
    }

    for(i = (*pozicia) - 1; (i >= 0 && p_pole[i] > prvok); i--)
        p_pole[i + 1] = p_pole[i];
    p_pole[i + 1] = prvok;
    (*pozicia)++;
}

// funkcia odstranuje prvy vyskyt zadaneho prvku, ak odstranovanie nenastane, tak vrati 0
int odstranPrvok(int prvok, int *pozicia, int *p_pole)
{
    int i, j;
    for(i = 0; i < *pozicia; i++)
    {
        if(prvok == p_pole[i])
        {
            for(j = i; j < *pozicia; j++)
            {
                p_pole[j]=p_pole[j + 1];
            }
            (*pozicia)--;
            printf("Prvy vyskyt prvku %d bol odstraneny.\n", prvok);
            return 1;
        }
    }
    return 0;
}
