#include <stdio.h>
#include <stdlib.h>

#define SIZE_X 3
#define SIZE_Y 4

// deklaracie funkcii
int** alokuj_pole(int m, int n);
void uvolni_pole(int** a, int m);
void vypis_pole(int** a, int m, int n);

int main(void)
{
    // staticky alokovane 2D pole
    printf("Staticky alokovane pole:\n");

    int a[SIZE_X][SIZE_Y];

    // naplnenie pola
    for (int i = 0; i < SIZE_X; i++)
        for (int j = 0; j < SIZE_Y; j++)
            a[i][j] = i + 1;

    // vypis pola
    for (int i = 0; i < SIZE_X; i++)
    {
        for (int j = 0; j < SIZE_Y; j++)
            printf("a[%d][%d] = %d\t", i, j, a[i][j]);
        printf("\n");
    }

    // dynamicky alokovane 2D pole cez funkcie
    printf("\nDynamicky alokovane pole:\n");

    int** b = alokuj_pole(SIZE_X, SIZE_Y);

    // naplnenie pola
    for (int i = 0; i < SIZE_X; i++)
        for (int j = 0; j < SIZE_Y; j++)
            b[i][j] = i + 1;

    vypis_pole(b, SIZE_X, SIZE_Y);

    uvolni_pole(b, SIZE_X);

    return 0;
}

// definicie funkcii
int** alokuj_pole(int m, int n)
{
    int** b;

    if ((b = (int**) malloc(m * sizeof(int*))) == NULL)
    {
        printf("Nedostatok pamate. Program sa konci.\n");
        exit(1);
    }

    for (int i = 0; i < m; i++)
        if((b[i] = (int*) malloc(n * sizeof(int))) == NULL)
        {
            printf("Nedostatok pamate. Program sa konci.\n");
            uvolni_pole(b, i);
            exit(1);
        }
    return b;

}

void vypis_pole(int** a, int m, int n)
{
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < n; j++)
            printf("a[%d][%d] = %d\t", i, j, a[i][j]);
        printf("\n");
    }
}

void uvolni_pole(int** a, int m)
{
    for (int i = 0; i < m; i++)
        free(a[i]);
    free(a);
    a = NULL;
}
