#include<stdio.h>

const int MAX = 10;

// deklaracie funkcii
int subor_nacitanie_matice(float A[][MAX], int m, int n, char *subor);
void klavesnica_nacitanie_matice(float A[][MAX], int m, int n);
void sucet_matic(float A[][MAX], float B[][MAX], float C[][MAX], int m, int n);
void vypis_matice(float A[][MAX], int m, int n);
int subor_vypis_matice(float A[][MAX], float B[][MAX], float C[][MAX], int m, int n);

int main(void)
{
    float A[MAX][MAX], B[MAX][MAX], C[MAX][MAX];
    int m, n;
    FILE *ft;

    // nacitanie rozmerov matic zo suboru, v pripade neuspechu z klavesnice
    ft = fopen("matice_rozmery.txt", "r");
    if (!ft)
    {
        printf("Nepodarilo sa otvorit subor.\n");
    }
    fscanf(ft, "%d %d", &m, &n);
    if(fclose(ft) == 0)
        printf("Subor \"matice_rozmery.txt\" sa podarilo zatvorit.\n");
    else
        printf("Subor \"matice_rozmery.txt\" sa nepodarilo zatvorit.\n");

    while(m <= 0 || m > MAX || n <= 0 || n > MAX)
    {
        printf ("Rozmery vstupnych matic nie su korektne, zadaj nove hodnoty: \n");
        scanf("%d %d", &m, &n);
    };

    // nacitanie prvkov matic zo suboru, v pripade neuspechu z klavesnice
    if(subor_nacitanie_matice(A, m, n, "matica1.txt") == 1)
    {
        printf("\nNacitanie prvkov zo suboru neprebehlo korektne, zadaj ich rucne.\n");
        klavesnica_nacitanie_matice(A, m, n);
    }

    if(subor_nacitanie_matice(B, m, n, "matica2.txt") == 1)
    {
        printf("\nNacitanie prvkov zo suboru neprebehlo korektne, zadaj ich rucne.\n");
        klavesnica_nacitanie_matice(B, m, n);
    }

    // scitanie matic
    sucet_matic(A, B, C, m, n);

    // vypis vysledku na obrazovku
    vypis_matice(A, m, n);
    printf("\n\t+\t\n");
    vypis_matice(B, m, n);
    printf("\n\t=\t\n");
    vypis_matice(C, m, n);

    // vypis vysledku do suboru
    if(subor_vypis_matice(A, B, C, m, n) == 1)
        printf("\nZapis do textoveho suboru neprebehol.\n");

    return 0;
}

// definicie funkcii
// funkcia na nacitanie prvkov matice zo suboru, v pripade neuspechu vrati 1
int subor_nacitanie_matice(float A[][MAX], int m, int n, char *subor)
{
    FILE *ft;
    int i, j, c;

    ft = fopen(subor, "r");
    if (!ft)
    {
        printf("Nepodarilo sa otvorit subor.\n");
        return 1;
    }

    for(i = 0; i < m; i++)
    {
        for(j = 0; j < n; j++)
        {
            fscanf(ft, "%f", &A[i][j]);
        }
    }

    if(fclose(ft) == 0)
        printf("Subor \"%s\" sa podarilo zatvorit.\n", subor);
    else
        printf("Subor \"%s\" sa nepodarilo zatvorit.\n", subor);
}

// funkcia na nacitanie prvkov matice z klavesnice
void klavesnica_nacitanie_matice(float A[][MAX], int m, int n)
{
    int i, j;
    printf ("Zadaj prvky matice (%d x %d) po riadkoch: \n", m, n);
    for(i = 0; i < m; i++)
    {
        for(j = 0; j < n; j++)
        {
            scanf("%f", &A[i][j]);
        }
    }
}

// funkcia na sucet matic
void sucet_matic(float A[][MAX], float B[][MAX], float C[][MAX], int m, int n)
{
    int i, j;
    for(i = 0; i < m; i++)
    {
        for(j = 0; j < n; j++)
        {
            C[i][j] = A[i][j] + B[i][j];
        }
    }
}

// funkcia na vypis prvkov matice na obrazovku
void vypis_matice(float A[][MAX], int m, int n)
{
    int i, j;
    for(i = 0; i < m; i++)
    {
        for(j = 0; j < n; j++)
        {
            printf("%.2f\t", A[i][j]);
        }
        printf("\n");
    }
}

// funkcia na vypis suctu matic do suboru, v pripade neuspechu vrati 1
int subor_vypis_matice(float A[][MAX], float B[][MAX], float C[][MAX], int m, int n)
{
    FILE *ft;
    int i, j;
    ft = fopen("sucet_matic.txt", "w");

    if (!ft)
    {
        printf("Nepodarilo sa vytvorit subor.\n");
        return 1;
    }

    for(i = 0; i < m; i++)
    {
        for(j = 0; j < n; j++)
        {
            fprintf(ft, "%.2f\t", A[i][j]);
        }
        fprintf(ft, "\n");
    }
    fprintf(ft,"\n\t+\t\n");
    for(i = 0; i < m; i++)
    {
        for(j = 0; j < n; j++)
        {
            fprintf(ft, "%.2f\t", C[i][j]);
        }
        fprintf(ft, "\n");
    }
    fprintf(ft, "\n\t=\t\n");
    for(i = 0; i < m; i++)
    {
        for(j = 0; j < n; j++)
        {
            fprintf(ft, "%.2f\t", B[i][j]);
        }
        fprintf(ft, "\n");
    }

    printf("\nZapis do textoveho suboru \"sucet_matic.txt\" prebehol v poriadku.\n");
}
